# H3 Max Reference to Video API

> Referans görüntüleri, videoları ve ses kliplerini kullanarak öznelerin tutarlılığını koruyan H3 Max video oluşturma

Referans varlıkların yönlendirdiği video oluşturur: en fazla 9 görüntü, 3 video ve 3 ses klibi; toplamda en fazla 12 dosya. İstem bunlara Image 1, Video 1, Audio 1 şeklinde atıfta bulunur. İsteğe bağlı ilk, orta (`middle_image_url` ile `middle_frame_time`) ve son kareler başlangıcı, ortayı ve sonu sabitler. `duration` 0.92 ile 15 saniye arasındadır ve `aspect_ratio` adaptive olabilir.

- Model id: `minimax/h3-max/reference-to-video`
- Made by: MiniMax
- Category: Reference to Video
- Output: video
- Price per second of your output video: from $0.05 / second of output video (cheapest run $0.05 (50 API credits))
- Run: `POST https://api.doitong.ru/v1/run/minimax/h3-max/reference-to-video`
- Quote: `POST https://api.doitong.ru/v1/quote/minimax/h3-max/reference-to-video`
- Docs page: https://doitong.com/tr/developers/models/minimax/h3-max/reference-to-video

## Pricing

Price: **from $0.05 / second of output video** (the lowest tier; the quote prices your exact input). Price per second of your output video: the input files are measured before the run (length, resolution, frame rate). The quote measures the same files and is exactly what the run charges.

Price by tier:

- 480P: $0.05 / second of output video
- 768P: $0.08 / second of output video
- 1080P: $0.16 / second of output video

The full example input below costs $0.40 = 400 API credits (5 s output video × $0.08 (768P)).

Prices are the upstream price in USD, paid from the API balance in API credits (1000 API credits = 1 USD). `POST https://api.doitong.ru/v1/quote/minimax/h3-max/reference-to-video` with the same JSON body returns the exact price for that input; the quote is exactly what a run charges. Invalid input is never charged and failed or canceled requests are refunded automatically.

## Input parameters

Send either the canonical name or the native field name (not both). Canonical names are the same across models.

| Parameter | Canonical name | Type | Required | Default | Allowed values / range | Description |
|---|---|---|---|---|---|---|
| `prompt` |  | string | yes |  | 1 – 50000 characters | Referansları varlık türü ve her referans listesindeki konumuyla tanımlayan video üretim talimatları; Audio 1, Video 1, Image 1, Image 2 gibi etiketler kullanılır. |
| `reference_image_urls` | `images` | array of image URL | no |  | ≤ 9 items | Konu veya stil referansı görsel URL'leri; tüm video ve ses referanslarıyla birlikte 12 dosyalık ortak sınırı paylaşır. Bu görselleri istemde liste konumuyla Image 1, Image 2 ve sonraki etiketleri kullanarak tanımlayın. |
| `reference_video_urls` |  | array of video URL | no |  | ≤ 3 items | İstemde liste konumuyla Video 1, Video 2 ve sonraki etiketler kullanılarak tanımlanan hareket veya diğer referans video URL'leri. Görsel, video ve ses referansları arasındaki ortak sınır 12 dosyadır; video kliplerinin her biri 2–15 saniye sürmeli ve toplamda 15 saniyeyi aşmamalıdır. |
| `reference_audio_urls` |  | array of audio URL | no |  | ≤ 3 items | Referans sesi URL'ler olarak sağlayın ve istemde klipleri Audio 1, Audio 2 ve sonraki etiketleri kullanarak tanımlayın. Her klip 2–15 saniye uzunluğunda olmalı ve toplam ses süresi 15 saniyeyi aşmamalıdır. Görsel, video ve ses referans türlerinden herhangi biri tek başına veya birlikte sağlanabilir; ortak üst sınır 12 dosyadır. |
| `image_url` | `image` | string (image URL) \| null | no |  | ≥ 1 characters | Tam açılış karesini tanımlayan ve çıktı tuvalini belirleyen isteğe bağlı görsel URL'si. Referans varlıkları konu tutarlılığını korur. |
| `middle_image_url` |  | string (image URL) \| null | no |  | ≥ 1 characters | Yalnızca yerel 480P veya 768P üretiminde ve hem başlangıç hem bitiş görseli sağlandığında kullanılabilen, middle_frame_time için isteğe bağlı kılavuz görsel. |
| `middle_frame_time` |  | number \| null | no |  | > 0, < 15 | Yalnızca middle_image_url ile kullanılabilen ve istenen videonun ilk ve son karelerinin tam arasındaki konumlarla sınırlı orta görsel yerleştirme zamanı. Başlangıçtan itibaren geçen saniyeleri sağlayın; değer en yakın 24 fps karesine yuvarlanır. |
| `end_image_url` | `end_image` | string (image URL) \| null | no |  | ≥ 1 characters | Videonun tam son karesini sağlanan görsele sabitleyen isteğe bağlı son görsel URL'si. |
| `duration` |  | number | no | `5` | 0.92 – 15 | Saniye cinsinden istenen süre; gerçek video uzunluğunun bu isteğin yaklaşık 0.7 saniye üzerine çıkmasına izin verir. |
| `resolution` |  | enum (string) | no | `768P` | `480P`, `768P`, `1080P` | Üretim çözünürlüğü seçimi: 1080P, seçilen çözünürlükte yerel üretim yerine 768P'de yerel olarak üretilen materyalin gizil iyileştirilmesini gerektirir. |
| `seed` |  | integer \| null | no |  |  | Rastgele üretim için tohum; belirtilmezse rastgele bir tane seçilir. |
| `enable_safety_checker` |  | boolean | no | `true` |  | Güvenlik denetleyicisi etkinleştirme; true denetimi etkinleştirir. |
| `prompt_expansion_mode` |  | string | yes | `balanced` |  | Üretim öncesi istem yeniden yazma çabası: 'quality', yaklaşık 30 saniyeye kadar daha zengin bir istem geliştirirken 'balanced' yaklaşık bir saniyede sonuç döndürür. İstem genişletmeyi atlamak için 'disabled' seçin. |
| `aspect_ratio` |  | enum (string) | no | `adaptive` | `adaptive`, `21:9`, `16:9`, `4:3`, `1:1`, `3:4`, `9:16` | Çıktı videosunun en-boy oranı. |
| `reference_conditions` |  | array of object {type, url} | no |  | ≤ 12 items | reference_*_urls yerine alternatif olarak sağlanan referans listesi; bunlarla birlikte kullanılamaz. Modlar arasındaki sıralama anlam taşır, bu nedenle işleme boyunca korunur. |
| `reference_conditions[].type` |  | enum (string) | yes |  | `image`, `video`, `audio` | Referansın modu; listedeki modlar arasındaki sıralama anlam taşır. |
| `reference_conditions[].url` |  | string | yes |  | ≥ 1 characters | Referans medyasının URL'si. |

File parameters (`images`, `reference_video_urls`, `reference_audio_urls`, `image`, `middle_image_url`, `end_image`) take a public `https://` URL, a `data:` URI up to 10 MB, or the `file_url` of an upload from `POST /files`.

## Example input

Required parameters only:

```json
{
  "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field",
  "prompt_expansion_mode": "balanced"
}
```

A fuller example:

```json
{
  "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field",
  "prompt_expansion_mode": "balanced"
}
```

## Run it

Set `DOITONG_API_KEY` to a key from https://doitong.com/developers/dashboard#keys. `?wait=20` returns the finished request in the same call when it is ready within 20 seconds; otherwise poll `GET /requests/{id}` (it also accepts `?wait=`), or pass `webhook_url`.

### curl

```bash
# Run the model; wait up to 20 s for the finished result in the same call
curl -X POST "https://api.doitong.ru/v1/run/minimax/h3-max/reference-to-video?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field",
    "prompt_expansion_mode": "balanced"
  }'

# Still "queued" or "running"? Poll with the id from the response:
curl "https://api.doitong.ru/v1/requests/REQUEST_ID?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY"
```

### JavaScript

```javascript
const API = "https://api.doitong.ru/v1";
const headers = {
  "Authorization": "Bearer " + process.env.DOITONG_API_KEY,
  "Content-Type": "application/json",
};

// Run the model; wait up to 20 s for the finished result in the same call
let res = await fetch(API + "/run/minimax/h3-max/reference-to-video?wait=20", {
  method: "POST",
  headers,
  body: JSON.stringify({
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field",
    "prompt_expansion_mode": "balanced"
  }),
});
let request = await res.json();
if (!res.ok) throw new Error(request.error.code + ": " + request.error.message);

// Not finished yet: long-poll until it is
while (request.status === "queued" || request.status === "running") {
  res = await fetch(API + "/requests/" + request.id + "?wait=20", { headers });
  request = await res.json();
}
if (request.status !== "succeeded") throw new Error(JSON.stringify(request.error));
console.log(request.outputs.map((o) => o.url), request.cost.credits + " API credits ($" + request.cost.usd + ")");
```

### Python

```python
import os
import requests

API = "https://api.doitong.ru/v1"
headers = {"Authorization": "Bearer " + os.environ["DOITONG_API_KEY"]}

payload = {
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field",
    "prompt_expansion_mode": "balanced",
}

# Run the model; wait up to 20 s for the finished result in the same call
r = requests.post(API + "/run/minimax/h3-max/reference-to-video", params={"wait": 20}, json=payload, headers=headers)
request = r.json()
if not r.ok:
    raise RuntimeError(request["error"]["code"] + ": " + request["error"]["message"])

# Not finished yet: long-poll until it is
while request["status"] in ("queued", "running"):
    request = requests.get(API + "/requests/" + request["id"], params={"wait": 20}, headers=headers).json()
if request["status"] != "succeeded":
    raise RuntimeError(request["error"])
print([o["url"] for o in request["outputs"]], request["cost"]["credits"], "API credits", "$" + request["cost"]["usd"])
```

### MCP

The MCP server at `https://api.doitong.ru/v1/mcp` exposes the tools `search_models`, `get_model`, `quote`, `run`, `get_request`, `cancel_request`, `list_requests`, `create_upload` and `get_account`. A `run` call for this model:

```json
{
  "jsonrpc": "2.0",
  "id": 1,
  "method": "tools/call",
  "params": {
    "name": "run",
    "arguments": {
      "model_id": "minimax/h3-max/reference-to-video",
      "input": {
        "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field",
        "prompt_expansion_mode": "balanced"
      },
      "wait_seconds": 20
    }
  }
}
```

## Response

Every call returns a request object. `status` is one of `queued`, `running`, `succeeded`, `failed`, `canceled`. `outputs` lists the generated files with URLs on our storage (kept forever, or 7 days with `?storage=temporary`; `storage` says which); `output` is the model's own result object with the same URLs.

```json
{
  "id": "req_8k2m4q7x1z9c3v5b6n0p2r4t",
  "object": "request",
  "model": "minimax/h3-max/reference-to-video",
  "status": "succeeded",
  "created_at": "2026-10-20T12:00:00Z",
  "started_at": "2026-10-20T12:00:02Z",
  "completed_at": "2026-10-20T12:00:09Z",
  "queue_position": null,
  "cost": {
    "credits": 400,
    "usd": "0.40",
    "charged": 400,
    "refunded": 0
  },
  "input": {
    "prompt": "A red fox trots through fresh snow at sunrise, soft golden light, shallow depth of field",
    "prompt_expansion_mode": "balanced"
  },
  "output": {
    "video": {
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.mp4",
      "content_type": "video/mp4",
      "file_name": "0-output.mp4",
      "file_size": 1843200
    },
    "expanded_prompt": "string",
    "seed": 42,
    "timings": {}
  },
  "outputs": [
    {
      "type": "video",
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.mp4",
      "content_type": "video/mp4",
      "file_size": 1843200,
      "width": 1280,
      "height": 720,
      "duration": 5,
      "stored": true
    }
  ],
  "error": null,
  "metrics": {
    "inference_seconds": 6.8
  },
  "urls": {
    "self": "https://api.doitong.ru/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t",
    "cancel": "https://api.doitong.ru/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t/cancel"
  }
}
```

### Output fields (`output`)

| Field | Type | Description |
|---|---|---|
| `video` | object {url, content_type, file_name, file_size} | Model tarafından üretilen video. |
| `expanded_prompt` | string \| null | Model için hazır genişletilmiş istem veya genişletilmiş metin yoksa null. null durumları genişletmenin devre dışı olması, genişletmenin değişiklik yapmaması ve genişletmenin modelin barındırılan API'si tarafından dahili olarak işlenmesidir. |
| `seed` | integer | Üretilen sonucu yeniden oluşturmak için kullanılan temel tohum. |
| `timings` | object \| null | Saniye cinsinden ifade edilen zamanlama ölçümleri; yalnızca arka uç zamanlamalarını raporlayan rotalarda kullanılabilir, aksi halde null. 'inference' girdisi, DiT gürültü giderme işleminin GPU arka ucunda ne kadar sürdüğünü ölçer. |

## Related models

- [MiniMax H3 Max Text to Video](https://doitong.com/developers/models/minimax/h3-max/text-to-video.md) (`minimax/h3-max/text-to-video`): from $0.0325 / second of output video
- [H3 Max Camera Controls](https://doitong.com/developers/models/minimax/h3-max/camera-controls.md) (`minimax/h3-max/camera-controls`): from $0.0325 / second
- [H3 Max Image to Video](https://doitong.com/developers/models/minimax/h3-max/image-to-video.md) (`minimax/h3-max/image-to-video`): from $0.0325 / second of output video
- [H3 Max](https://doitong.com/developers/models/minimax/h3-max/insert-video.md) (`minimax/h3-max/insert-video`): from $0.05 / second
- [H3 Max Extend Video](https://doitong.com/developers/models/minimax/h3-max/extend-video.md) (`minimax/h3-max/extend-video`): from $0.05 / second of output video
- [H3 Max Recast](https://doitong.com/developers/models/minimax/h3-max/recast.md) (`minimax/h3-max/recast`): from $0.30 / second of input video
- [H3 Max Reframe](https://doitong.com/developers/models/minimax/h3-max/reframe-video.md) (`minimax/h3-max/reframe-video`): from $0.05 / second of input video
- [H3 Max Relight](https://doitong.com/developers/models/minimax/h3-max/relight.md) (`minimax/h3-max/relight`): from $0.05 / second of input video

## Links

- HTML page: https://doitong.com/developers/models/minimax/h3-max/reference-to-video
- All models and guides for AI agents: https://doitong.com/developers/llms.txt
- OpenAPI 3.1 with this model's typed request body: https://doitong.com/developers/openapi.json?model=minimax/h3-max/reference-to-video
- Errors: https://doitong.com/developers/docs/errors
- Model details as JSON: https://api.doitong.ru/v1/models/minimax/h3-max/reference-to-video
